unit hiExportXLS;

interface

uses Kol,windows,Share,Debug,KOLXLSDocument;

type
  THIExportXLS = class(TDebug)
   private
     FXLS: TXLSDocument;
   public
     FileName:string;
     _prop_Columns: string;
     _prop_FileName: string;
     _data_FileName: THI_Event;
     _data_Matrix: THI_Event;

     _event_onEndExport: THI_Event;
     _event_onMaxProgress: THI_Event;
     _event_onProgress: THI_Event;

     procedure _work_doExportXLS(var _Data: TData; Index:word);

  end;

implementation

procedure THIExportXLS._work_doExportXLS;
var
  c,r,i: integer;
  m: PMatrix;
  s,tmp: string;
  ColLst: PStrList;
  Start: integer;
begin
  m := ReadMatrix(_data_Matrix);
  if m = nil then exit;

  ColLst := NewStrList;
  ColLst.Text := _prop_Columns;

  FXLS := TXLSDocument.Create;
  for i := 0 to ColLst.Count-1 do
  begin
    tmp := ColLst.Items[i];
    s := GetTok(tmp,'=');
    FXLS.ColWidth(i,i,Str2Int(tmp));
    ColLst.Items[i] := s;
    FXLS.Text(0,i,s);
  end;

  if ColLst.Count > 0 then Start := 1 else Start := 0;
  ColLst.Free;

  _hi_onEvent(_event_onMaxProgress,(m._Rows*m._Cols));
  i := 0;

  for r := Start to (m._Rows-1)+Start do
    for c := 0 to m._Cols-1 do
    begin
      s := ToString(m._Get(c,r-Start));
      if IsReal(s) then
        FXLS.FloatingNumber(r,c,str2Double(s))
      else if IsInteger(s) then
        FXLS.IntegerNumber(r,c,str2int(s))
      else FXLS.Text(r,c,s);
      inc(i);
      _hi_onEvent(_event_onProgress,i);
    end;

  _hi_onEvent(_event_onProgress,0);

  FXLS.SaveToFile(ReadString(_Data,_data_Filename,_prop_FileName));
  FXLS.Free;

  _hi_onEvent(_event_onEndExport);
end;

end.
